{
  "cells": [
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "# 15wk-2: 기말고사 풀이\n",
        "\n",
        "최규빈  \n",
        "2023-06-20\n",
        "\n",
        "<a href=\"https://colab.research.google.com/github/guebin/PP2023/blob/main/posts/2023-06-19-15wk-2-fin.ipynb\"><img src=\"https://colab.research.google.com/assets/colab-badge.svg\" style=\"text-align: left\"></a>\n",
        "\n",
        "**제출은 `*.ipynb`, `*.html`, `*.pdf` 파일로 제출할 것**\n",
        "\n",
        "-   `ipynb` 파일형태제출을 권장함.\n",
        "\n",
        "# imports"
      ],
      "id": "0c68ff20-5982-488e-8576-9975768f42f2"
    },
    {
      "cell_type": "code",
      "execution_count": 5,
      "metadata": {},
      "outputs": [],
      "source": [
        "import numpy as np\n",
        "import matplotlib.pyplot as plt\n",
        "import datetime"
      ],
      "id": "21a5e3fe-6648-481d-8bfe-554d59f978e6"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "# `1`. 묵찌빠 (150점)\n",
        "\n",
        "> **묵찌빠**\n",
        ">\n",
        "> ref: <https://namu.wiki/w/묵찌빠>\n",
        ">\n",
        "> 묵찌빠는 가위바위보의 변형 놀이이다. 보통 가위바위보의 게임과 연이어\n",
        "> 진행되는데, 가위바위보 승부 이후 이긴 사람이 공격권을 가지고,\n",
        "> 묵(바위)/찌(가위)/빠(보자기) 가운데 하나를 외치는 동시에 말한 것과\n",
        "> 일치하도록 손 모양을 바꾼다. 공격권을 가진 사람의 손 모양이\n",
        "> 상대(수비권을 가진 사람)의 손 모양과 일치하면 공격권을 가진 사람의\n",
        "> 승리한다. 승부가 갈리지 않았을 경우에는 다시 가위바위보를 하는 것이\n",
        "> 아니라, 현 상태에서 가위바위보 규칙 상 이긴 사람이 공격권을 가져가게\n",
        "> 된다.\n",
        "\n",
        "`(1)` 아래는 RPS_BASE 클래스의 구현예시이다."
      ],
      "id": "04af74d4-1a9c-4370-b085-59287f8e58a7"
    },
    {
      "cell_type": "code",
      "execution_count": 7,
      "metadata": {},
      "outputs": [],
      "source": [
        "class RPS_BASE:\n",
        "    def __init__(self,candidate):\n",
        "        self.candidate = candidate\n",
        "        self.actions = list() \n",
        "    def __setitem__(self,index,val):\n",
        "        self.actions[index] = val\n",
        "    def __getitem__(self,item):\n",
        "        return self.actions[item]        \n",
        "    def __len__(self):\n",
        "        return len(self.actions)\n",
        "    def __eq__(self,other):\n",
        "        return self[-1] == other[-1]\n",
        "    def __gt__(self,other):\n",
        "        return [self[-1],other[-1]] in [['묵','찌'],['찌','빠'],['빠','묵']]\n",
        "    def __ge__(self,other):\n",
        "        return (self == other) or (self > other)\n",
        "    def __lt__(self,other):\n",
        "        return not (self >= other)\n",
        "    def __le__(self,other):\n",
        "        return (self == other) or (self < other)    \n",
        "    def _repr_html_(self):\n",
        "        html_str = \"\"\"\n",
        "        낼 수 있는 패: {} <br/>\n",
        "        기록: {}\n",
        "        \"\"\"        \n",
        "        return html_str.format(self.candidate,self.actions)       \n",
        "    def pick(self):\n",
        "        self.actions.append(np.random.choice(self.candidate))        "
      ],
      "id": "19c7784a-2278-4b08-99b5-b4c1b2c73c0f"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "이 클래스에서 아래와 같은 2명의 플레이어 인스턴스를 생성하라.\n",
        "\n",
        "-   `a`: \\[‘묵’,‘찌’\\] 중에 하나를 랜덤으로 선택\n",
        "-   `b`: \\[‘찌’,‘빠’\\] 중에 하나를 랜덤으로 선택\n",
        "\n",
        "두 인스턴스를 100회 랜덤대결하고 결과를 기록하라. 어떠한 플레이어가 더\n",
        "유리한가?\n",
        "\n",
        "> 답안은 100회중 a몇회 승리, b몇회 승리와 같은 숫자형식으로만 나오면\n",
        "> 인정한다. (코드를 정리하거나 별도의 클래스를 만드는 것을 요구하지\n",
        "> 않음)\n",
        "\n",
        "`(풀이)`"
      ],
      "id": "6509949b-89b2-4b78-87ab-78140eb56299"
    },
    {
      "cell_type": "code",
      "execution_count": 23,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = RPS_BASE(['묵','찌'])\n",
        "b = RPS_BASE(['찌','빠'])"
      ],
      "id": "da9b2023-e885-4720-bbfd-78e1dbb0a753"
    },
    {
      "cell_type": "code",
      "execution_count": 24,
      "metadata": {},
      "outputs": [],
      "source": [
        "rslt = []\n",
        "for _ in range(100):\n",
        "    a.pick()\n",
        "    b.pick()\n",
        "    if a>b: \n",
        "        rslt.append('a')\n",
        "    elif a==b: \n",
        "        rslt.append('-')\n",
        "    else: \n",
        "        rslt.append('b')"
      ],
      "id": "2d61ea17-7f8b-48a2-8a68-122fdcda1261"
    },
    {
      "cell_type": "code",
      "execution_count": 25,
      "metadata": {},
      "outputs": [],
      "source": [
        "{'a의승리':rslt.count('a'),'무승부':rslt.count('-'),'b의승리':rslt.count('b')}"
      ],
      "id": "fc2bb7e8-417f-4693-8b33-01efa2d73bd3"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "------------------------------------------------------------------------\n",
        "\n",
        "`(2)` RPS_BASE에서 아래와 같은 두명의 플레이어 인스턴스를 생성하라.\n",
        "\n",
        "-   `a`: \\[‘묵’,‘찌’,‘빠’\\] 중 하나를 랜덤으로 선택\n",
        "-   `b`: \\[‘찌’,‘빠’\\] 중 하나를 랜덤으로 선택\n",
        "\n",
        "아래와 같은 a,b의 attribute을 변경하라."
      ],
      "id": "90184d9a-3723-45d9-abdb-b2015127d2c0"
    },
    {
      "cell_type": "code",
      "execution_count": 672,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.modes = [None]\n",
        "a.actions = [None] \n",
        "b.modes = [None]\n",
        "b.actions = [None]"
      ],
      "id": "13b5e638-5c0b-4d39-bce4-d1efe500df03"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "플레이어 a,b를 이용하여 반복적으로 가위바위보 대결을 수행하고 아래와\n",
        "같이 대결결과에 따라 공격권을 결정하는 함수 `mul`을 만들어라.\n",
        "\n",
        "**경우1: 플레이어 a가 승리할 경우**\n",
        "\n",
        "-   a가 공격모드, b가 수비모드가 된다.\n",
        "-   `a.modes`에는 ‘Attack’ 이 `b.modes`에는 `Defence`가 추가된다.\n",
        "-   `a.actions`와 `b.actions`는 각각의 플레이어가 선택한 패(묵,찌,빠)가\n",
        "    기록된다.\n",
        "\n",
        "**경우2: 플레이어 b가 승리할 경우**\n",
        "\n",
        "-   b가 공격모드, a가 수비모드가 된다.\n",
        "-   `b.modes`에는 ‘Attack’ 이 `a.modes`에는 `Defence`가 추가된다.\n",
        "-   `a.actions`와 `b.actions`는 각각의 플레이어가 선택한 패(묵,찌,빠)가\n",
        "    기록된다.\n",
        "\n",
        "**경우3: 비길경우**\n",
        "\n",
        "-   공격권의 변화는 없다.\n",
        "-   `a.modes`,`b.modes`는 각각 이전의 값이 추가된다.\n",
        "-   `a.actions`와 `b.actions`는 각각의 플레이어가 선택한 패(묵,찌,빠)가\n",
        "    기록된다.\n",
        "\n",
        "아래는 함수 mul을 사용한 예시이다.\n",
        "\n",
        "**시점1: 둘다 찌를 내어 공격권을 아무도 획득하지못함**"
      ],
      "id": "bf39929e-1908-4fd5-aa11-900272007b57"
    },
    {
      "cell_type": "code",
      "execution_count": 693,
      "metadata": {},
      "outputs": [],
      "source": [
        "mul(a,b)"
      ],
      "id": "c6b8c6a8-5447-405f-81c7-15bea3a79c76"
    },
    {
      "cell_type": "code",
      "execution_count": 702,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "813fce95-0054-4cb3-bb6d-6788dce352e0"
    },
    {
      "cell_type": "code",
      "execution_count": 703,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "948237f0-44f5-4ad5-a099-dbaa623a38f7"
    },
    {
      "cell_type": "code",
      "execution_count": 704,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.modes"
      ],
      "id": "b2a45c21-dfd5-45e6-b14f-7c66d6b62b76"
    },
    {
      "cell_type": "code",
      "execution_count": 705,
      "metadata": {},
      "outputs": [],
      "source": [
        "b.modes"
      ],
      "id": "f5d82d9a-c9ba-4d7f-90b7-c507b054f9e0"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**시점2:** 이번에도 둘다 찌를 내어 아무도 공격권을 획득하지 못함"
      ],
      "id": "b0bb9af1-b680-411a-8f1d-7536f1d463c8"
    },
    {
      "cell_type": "code",
      "execution_count": 706,
      "metadata": {},
      "outputs": [],
      "source": [
        "mul(a,b)"
      ],
      "id": "e143c1d8-1f73-42d9-ad37-10013b6d8dd0"
    },
    {
      "cell_type": "code",
      "execution_count": 707,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "641e1aa1-7893-48df-88b4-15cf33f43b8d"
    },
    {
      "cell_type": "code",
      "execution_count": 708,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "4a57f2c9-3dfd-41ba-9d5e-746e910ff1d5"
    },
    {
      "cell_type": "code",
      "execution_count": 709,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.modes"
      ],
      "id": "98e5c03f-39ed-4377-8cbf-cfc6881f8d6f"
    },
    {
      "cell_type": "code",
      "execution_count": 710,
      "metadata": {},
      "outputs": [],
      "source": [
        "b.modes"
      ],
      "id": "8d42dad4-8121-41ad-8249-b9687fa84d76"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**시점3:** 이번에는 a가 공격권을 획득 (묵\\>찌)"
      ],
      "id": "803b5578-a490-4021-ac11-21f9fed5de5b"
    },
    {
      "cell_type": "code",
      "execution_count": 711,
      "metadata": {},
      "outputs": [],
      "source": [
        "mul(a,b)"
      ],
      "id": "37981f02-123d-4902-90c1-123fc40a6f46"
    },
    {
      "cell_type": "code",
      "execution_count": 712,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "74ded083-6c72-4069-be80-3a3ea982a7bc"
    },
    {
      "cell_type": "code",
      "execution_count": 713,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "629fa94f-03c9-4c9e-91de-1d8a95dcece8"
    },
    {
      "cell_type": "code",
      "execution_count": 714,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.modes"
      ],
      "id": "10c1a068-fe54-45d8-84aa-3309e8bb0a80"
    },
    {
      "cell_type": "code",
      "execution_count": 715,
      "metadata": {},
      "outputs": [],
      "source": [
        "b.modes"
      ],
      "id": "72e42d98-b8a9-43a1-9722-14b496d9e303"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**시점4:** 이번에는 b가 공격권을 획득 (찌\\>빠)"
      ],
      "id": "69dc11be-df30-46b1-83f4-cbfe8fc4c246"
    },
    {
      "cell_type": "code",
      "execution_count": 716,
      "metadata": {},
      "outputs": [],
      "source": [
        "mul(a,b)"
      ],
      "id": "787eb3fa-3c4d-4c7b-b836-a4eb5de422e2"
    },
    {
      "cell_type": "code",
      "execution_count": 717,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "c061b7c0-ed91-47c9-8f27-49e68bd7e5d9"
    },
    {
      "cell_type": "code",
      "execution_count": 718,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "74cfc258-af52-4b76-9b93-254622cdf7fd"
    },
    {
      "cell_type": "code",
      "execution_count": 719,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.modes"
      ],
      "id": "cfd3ecf1-4e32-4569-b13d-47803155b859"
    },
    {
      "cell_type": "code",
      "execution_count": 720,
      "metadata": {},
      "outputs": [],
      "source": [
        "b.modes"
      ],
      "id": "2ed06118-1734-4425-a896-c5ae11736f83"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(풀이)` – 생략, (3)번 풀이로 대체\n",
        "\n",
        "------------------------------------------------------------------------\n",
        "\n",
        "`(3)` RPS_BASE를 상속받아 MookjjibbaPlayer라는 새로운 클래스를 정의하라.\n",
        "MookjjibbaPlayer 클래스에서 아래의 메소드를 새롭게 정의 혹은 재정의하여\n",
        "\n",
        "1.  `__init__`\n",
        "2.  `_repr_html_`\n",
        "3.  `__mul__`\n",
        "4.  `reset`\n",
        "\n",
        "인스턴스가 아래와 같은 동작을 하도록 설계하라.\n",
        "\n",
        "**시점0: 생성예시 (`__init__`)**"
      ],
      "id": "01133d4f-a160-427f-a954-578530e14320"
    },
    {
      "cell_type": "code",
      "execution_count": 765,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=MookjjibbaPlayer(['묵','찌','빠'])\n",
        "b=MookjjibbaPlayer(['묵','찌','빠'])"
      ],
      "id": "8984389b-00c8-492f-8bc5-cd1f2af91cdf"
    },
    {
      "cell_type": "code",
      "execution_count": 766,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.actions"
      ],
      "id": "e13ad5c3-4193-40da-9e42-96222ced7ee0"
    },
    {
      "cell_type": "code",
      "execution_count": 767,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.modes"
      ],
      "id": "fa83fcca-8076-4559-92fd-365e4d459c19"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> **`__init__` 의 동작**\n",
        ">\n",
        "> 1.  슈퍼클래스(RPS_BASE)의 `__init__`을 동작시킴\n",
        "> 2.  MookjjibbaPlayer의 인스턴가 가지는 actions, modes 값을 \\[None\\]\n",
        ">     으로 초기화\n",
        "\n",
        "**시점0: 출력예시(`_repr_html_`)**"
      ],
      "id": "69245221-d2e9-4036-abd0-2fe54f3d56db"
    },
    {
      "cell_type": "code",
      "execution_count": 770,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "0c1fb8c9-075d-4809-adce-7b6f3e853023"
    },
    {
      "cell_type": "code",
      "execution_count": 771,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "686ccd5a-4e52-4f66-8e66-48b9b3e1d646"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> **`_repr_html_` 의 동작**\n",
        ">\n",
        "> 위와 같이 “낼 수 있는 패”, “기록”, “모드” 가 함께 출력되도록 설계할 것\n",
        "\n",
        "**시점1: 대결 및 결과출력 (`__mul__`, `_repr_html_`)**"
      ],
      "id": "51597a0d-5886-4f3c-970a-a2c8356dd65c"
    },
    {
      "cell_type": "code",
      "execution_count": 772,
      "metadata": {},
      "outputs": [],
      "source": [
        "a*b"
      ],
      "id": "0cb07dd4-8247-40d5-aa0f-5a654ef3ffa0"
    },
    {
      "cell_type": "code",
      "execution_count": 773,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "bbce9c1e-5550-491e-8fe7-9d09cc0e44c6"
    },
    {
      "cell_type": "code",
      "execution_count": 774,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "42d07d26-a154-4df5-a176-b8084e3f40f8"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> **`__mul__` 의 동작**\n",
        ">\n",
        "> 1.  두 플레이어의 대결을 진행\n",
        "> 2.  결과를 보고 modes 의 값을 update\n",
        ">\n",
        "> 위의 상황은 두 플레이어 모두 “묵”을 내어 어느쪽도 공격권을 가지지 못한\n",
        "> 상태를 의미\n",
        "\n",
        "**시점2: 대결 및 결과출력 (`__mul__`, `_repr_html_`)**"
      ],
      "id": "4ac0b4aa-9cec-49c5-839c-c3317433f54e"
    },
    {
      "cell_type": "code",
      "execution_count": 775,
      "metadata": {},
      "outputs": [],
      "source": [
        "a*b"
      ],
      "id": "2435db8a-0efb-440a-8bdc-8c32ff209eb5"
    },
    {
      "cell_type": "code",
      "execution_count": 776,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "c2e33f6d-2edf-46f1-8cce-105a5c7c0e4b"
    },
    {
      "cell_type": "code",
      "execution_count": 777,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "177b8374-6bda-4bc3-a3f4-a17698cdc597"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> **`__mul__` 의 동작**\n",
        ">\n",
        "> 1.  두 플레이어의 대결을 진행\n",
        "> 2.  결과를 보고 modes 의 값을 update\n",
        ">\n",
        "> 위의 상황은 a가 묵, b가 빠를 내어 b가 공격권을 획득한 상황을 의미\n",
        "\n",
        "**시점3: 대결결과의 초기화 (`reset`)**"
      ],
      "id": "57d7d13b-6c9a-4367-9d46-fa0af5b6a3db"
    },
    {
      "cell_type": "code",
      "execution_count": 778,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "c2d05499-b3e0-4fcb-8eea-c2bca07ea62b"
    },
    {
      "cell_type": "code",
      "execution_count": 779,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.reset()"
      ],
      "id": "b5189cd5-443b-4ce0-a932-5162b25a9c43"
    },
    {
      "cell_type": "code",
      "execution_count": 780,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "751baed7-6444-41d2-aeea-17ded64758e1"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> **`reset` 의 동작**\n",
        ">\n",
        "> 1.  플레이어의 기록을 초기화\n",
        "> 2.  플레이어의 모드를 초기화\n",
        "\n",
        "`(풀이)`"
      ],
      "id": "9f1f7d7e-787f-47fc-ba88-f8d8988016ca"
    },
    {
      "cell_type": "code",
      "execution_count": 26,
      "metadata": {},
      "outputs": [],
      "source": [
        "class MookjjibbaPlayer(RPS_BASE):\n",
        "    def __init__(self,candidate):\n",
        "        super().__init__(candidate)\n",
        "        self.modes = [None]\n",
        "        self.actions = [None]\n",
        "    def __mul__(self,other):\n",
        "        self.pick()\n",
        "        other.pick()\n",
        "        if self > other:\n",
        "            self.modes.append('Attack')\n",
        "            other.modes.append('Defence')\n",
        "        elif self < other:\n",
        "            self.modes.append('Defence')\n",
        "            other.modes.append('Attack')\n",
        "        else: \n",
        "            self.modes.append(self.modes[-1]) \n",
        "            other.modes.append(other.modes[-1])\n",
        "    def _repr_html_(self):\n",
        "        html_str = \"\"\"\n",
        "        낼 수 있는 패: {} <br/>\n",
        "        기록: {} <br/>\n",
        "        모드: {} <br/>\n",
        "        \"\"\"        \n",
        "        return html_str.format(self.candidate,self.actions,self.modes)\n",
        "    def reset(self):\n",
        "        self.__init__(self.candidate)"
      ],
      "id": "365e5ef5-7977-408d-9721-b7caa4ffb515"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**`__init__`, `_repr_html_`** 체크"
      ],
      "id": "c57d8ef9-cac7-4695-b6f0-f44f885a57ad"
    },
    {
      "cell_type": "code",
      "execution_count": 36,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=MookjjibbaPlayer(['묵','찌','빠'])\n",
        "b=MookjjibbaPlayer(['묵','찌','빠'])"
      ],
      "id": "497917e5-ba58-4c29-95dc-c980325686f5"
    },
    {
      "cell_type": "code",
      "execution_count": 37,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "d112f6b1-602f-4838-ae1c-07695c01d8c3"
    },
    {
      "cell_type": "code",
      "execution_count": 38,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "beca7342-95db-4bdb-aefc-32e42704c9ad"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**`__mul__`, `_repr_html_`, `reset`** 체크"
      ],
      "id": "8d427910-9e56-455d-a0bf-fba78a445b21"
    },
    {
      "cell_type": "code",
      "execution_count": 39,
      "metadata": {},
      "outputs": [],
      "source": [
        "for _ in range(3):\n",
        "    a*b"
      ],
      "id": "7d824723-2cc0-477b-81c4-f03eed4e37bf"
    },
    {
      "cell_type": "code",
      "execution_count": 40,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "55ccccca-9e23-4e92-b37b-5d5871bd0ad8"
    },
    {
      "cell_type": "code",
      "execution_count": 41,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "f8f3e863-272d-41ce-963e-aba6de935dfa"
    },
    {
      "cell_type": "code",
      "execution_count": 42,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.reset()"
      ],
      "id": "6c02f3c3-72c2-4cc8-9d5f-2d562f2ceee7"
    },
    {
      "cell_type": "code",
      "execution_count": 43,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "ebfc6aa5-3f31-4773-b0ae-3bf948d65636"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "------------------------------------------------------------------------\n",
        "\n",
        "`(4)` `(3)` 에서 생성된 MookjjibbaPlayer의 두 개의 인스턴스 a,b를\n",
        "입력으로 받고 최초공격권을 결정하는 함수 `jumpball`을 설계하라.\n",
        "\n",
        "아래는 jumpball함수의 사용예시이다."
      ],
      "id": "8c6001f4-630a-4737-9ef4-0a0b0c669ab8"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "49527017-c897-492c-8065-92acc37c222d"
    },
    {
      "cell_type": "code",
      "execution_count": 875,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "670e06d5-c03f-4ea2-a9f2-77df420346c6"
    },
    {
      "cell_type": "code",
      "execution_count": 876,
      "metadata": {},
      "outputs": [],
      "source": [
        "jumpball(a,b)"
      ],
      "id": "78af2550-0da2-4ad7-a052-134c5dcc9b04"
    },
    {
      "cell_type": "code",
      "execution_count": 877,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "e0217bbe-72f6-4805-96cd-cf6bbeabf46a"
    },
    {
      "cell_type": "code",
      "execution_count": 878,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "05e63fee-8ac2-4ff0-b80b-85373803cf52"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> 처음 2번의 가위,바위,보는 비겼으나 이후에 b가 승리하여 초기공격권을\n",
        "> b가 획득하였음.\n",
        "\n",
        "`(풀이)` – 생략, (5)번풀이 참고\n",
        "\n",
        "------------------------------------------------------------------------\n",
        "\n",
        "`(5)` 지금까지 코드를 바탕으로\n",
        "\n",
        "-   a: \\[‘묵’,‘찌’\\] 중 하나를 랜덤으로 고르는 플레이어\n",
        "-   b: \\[‘찌’,‘빠’\\] 중 하나를 랜덤으로 고르는 플레이어\n",
        "\n",
        "를 설정하여 100회 가상대결을 진행하라. 100회 가상대결결과를 제시하라.\n",
        "\n",
        "(참고) – 아래는 제가 구현한 예시입니다. 참고용일 뿐이며 이와 같은\n",
        "방식으로 구현할 필요는 없습니다.\n",
        "\n",
        "**1. a,b 두명의 플레이어 생성**"
      ],
      "id": "6e46de99-704c-4e93-b2a8-5dd1de30ebd5"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=MookjjibbaPlayer(['묵','찌'])\n",
        "b=MookjjibbaPlayer(['찌','빠'])"
      ],
      "id": "d2e3ce17-77e5-4402-8f59-db68b9d9a0d6"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "954789d6-5e6e-42a7-93bb-35e8a72c0914"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "6014c33c-3058-41ae-8ba5-939783ca1677"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> a,b 플레이어가 초기화\n",
        "\n",
        "**2. a,b 두명의 플레이어를 입력으로 하여 게임1을 생성후 1회 게임진행**"
      ],
      "id": "14131f35-ece0-4b81-b1e0-734ec858680a"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "game = PlayMookjjibba(a,b)"
      ],
      "id": "9ee012f7-062e-46d6-b8f9-cbcd390885b2"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "game.play()"
      ],
      "id": "56aae94f-6e9f-4021-b0f2-4c667fa9cfe8"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "a533429f-928e-4f70-8675-43f025436ec7"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "4b5e9448-7397-4561-b385-208d6b62dbc6"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> a가 찌, b가 빠를 내어 최초 공격권을 a가 획득하였지만 이후 공격권을\n",
        "> 상실한 상실함. 이후 4번째 가위바위보에서 b가 a가 동시에 찌를 내며 b의\n",
        "> 승리로 마무리됨\n",
        "\n",
        "**3. game.records 에 b의 승리가 기록되어 있음**"
      ],
      "id": "22f8c1fb-cbb9-4caa-9876-ceffc86ad44a"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "game.records "
      ],
      "id": "1efcadb0-b63d-4600-a1e7-25bcbaf1f6ba"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**4. 1회 대결기록을 삭제하고 또 다른 게임을 진행: 이번에는 a의 승리**"
      ],
      "id": "02bfafd1-c0eb-4da8-bfa5-6376616567c0"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "game.reset_player_history()"
      ],
      "id": "61f29fac-80af-490a-b707-dc91390e531b"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "f459dade-2c1f-4463-bc5a-f875bc16eb32"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "47e5f29d-33f0-43c4-9eda-79e03cf64016"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "game.play()"
      ],
      "id": "18b8ef2c-4fc2-4983-8b82-1c602125d129"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "1e4e79e1-8891-43bc-b292-e0f24d19710b"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "971ae2e2-7167-43e9-840a-eb4b7ed0b168"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> 공격권은 2번만에 A가 획득, 1번의 공격을 통하여 마무리\n",
        "\n",
        "**5. 이번에는 a의 승리가 기록됨**"
      ],
      "id": "c4f4d0c8-d947-4d6c-bc75-238326950e77"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "game.records"
      ],
      "id": "eedbd398-4d5b-4aba-9a27-ec7a0c0bb25c"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(풀이)`"
      ],
      "id": "0a10a8d6-821f-4074-9310-bfa599ea530e"
    },
    {
      "cell_type": "code",
      "execution_count": 56,
      "metadata": {},
      "outputs": [],
      "source": [
        "class PlayMookjjibba:\n",
        "    def __init__(self,a,b):\n",
        "        self.a = a\n",
        "        self.b = b\n",
        "        self.records = list()\n",
        "    def reset_player_history(self):\n",
        "        self.a.reset()\n",
        "        self.b.reset()\n",
        "    def record(self):\n",
        "        if self.a.modes[-1] == 'Attack':\n",
        "            self.records.append('a')\n",
        "        else:\n",
        "            self.records.append('b')\n",
        "    def jumpball(self):\n",
        "        self.a * self.b \n",
        "        while self.a == self.b:\n",
        "            self.a * self.b \n",
        "    def play(self):\n",
        "        self.jumpball()\n",
        "        while self.a != self.b:\n",
        "            self.a * self.b \n",
        "        self.record()"
      ],
      "id": "49b3334e-957f-4512-8fd7-7c399de2577d"
    },
    {
      "cell_type": "code",
      "execution_count": 57,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=MookjjibbaPlayer(['묵','찌'])\n",
        "b=MookjjibbaPlayer(['찌','빠'])\n",
        "game = PlayMookjjibba(a,b)"
      ],
      "id": "231c1d74-0942-43ff-91a1-cae9262a5918"
    },
    {
      "cell_type": "code",
      "execution_count": 58,
      "metadata": {},
      "outputs": [],
      "source": [
        "for _ in range(1000):\n",
        "    game.play()"
      ],
      "id": "f5e2b86d-048a-4405-9923-733811b40293"
    },
    {
      "cell_type": "code",
      "execution_count": 59,
      "metadata": {},
      "outputs": [],
      "source": [
        "{'a':game.records.count('a'),'b':game.records.count('b')}"
      ],
      "id": "339e5e5d-8eec-4332-be46-03c353bb1b24"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "------------------------------------------------------------------------\n",
        "\n",
        "# `2`. 종합문항 (50점)\n",
        "\n",
        "`(1)` LinearRegression 이라는 이름의 클래스를 만들고 아래의 기능을\n",
        "넣어라.\n",
        "\n",
        "**`__init__`**: “클래스 $\\to$ 인스턴스” 인 시점에 길이가 $n$인 numpy\n",
        "array ${\\bf x}=(x_1,\\dots,x_n)$, ${\\bf y}=(y_1,\\dots,y_n)$을 입력으로\n",
        "받아 내부에 저장한다.\n",
        "\n",
        "**`fit`**: fit은 내부에 저장된 ${\\bf x}$, ${\\bf y}$를 이용하여\n",
        "$\\hat{\\bf y}=(\\hat{y}_1,\\dots,\\hat{y}_n)$을 계산하는 역할을 한다. 계산은\n",
        "아래의 수식을 이용한다.\n",
        "$$\\hat{\\bf y}= {\\bf X}({\\bf X}^T {\\bf X})^{-1}{\\bf X}^T {\\bf y}, \\quad {\\bf X}=\\begin{bmatrix} 1 & x_1 \\\\ 1 & x_2 \\\\ \\dots \\\\ 1 & x_n \\end{bmatrix}$$\n",
        "\n",
        "**`plot`**: plot은 $(x_i,y_i)$와 $(x_i,\\hat{y}_i)$를 시각화하는 역할을\n",
        "한다.\n",
        "\n",
        "아래의 자료를 LinearRegression의 입력으로 받고 시각화하는 분석을\n",
        "수행하라."
      ],
      "id": "56526984-8702-4186-93e6-cee7b733f2c8"
    },
    {
      "cell_type": "code",
      "execution_count": 62,
      "metadata": {},
      "outputs": [
        {
          "output_type": "display_data",
          "metadata": {},
          "data": {
            "image/png": "iVBORw0KGgoAAAANSUhEUgAAAXIAAAD4CAYAAADxeG0DAAAAOXRFWHRTb2Z0d2FyZQBNYXRwbG90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\n"
          }
        }
      ],
      "source": [
        "x = np.linspace(0,1,100)\n",
        "y = 2*x + np.random.normal(size=100)\n",
        "plt.plot(x,y,'o')"
      ],
      "id": "7c268703-3d76-4583-94b1-b1c6196b13d7"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(풀이)`"
      ],
      "id": "19029e31-55ee-45d7-8ee8-a39981c5281d"
    },
    {
      "cell_type": "code",
      "execution_count": 63,
      "metadata": {},
      "outputs": [],
      "source": [
        "class LinearRegression: \n",
        "    def __init__(self,x,y):\n",
        "        self.x = x\n",
        "        self.y = y \n",
        "    def fit(self):\n",
        "        n = len(self.x)\n",
        "        self.X = np.stack([np.ones(n),self.x],axis=1)\n",
        "        self.yhat = self.X@np.linalg.inv(self.X.T@self.X)@self.X.T@self.y \n",
        "    def plot(self):\n",
        "        plt.plot(self.x,self.y,'o',label=r'$(x_i,y_i)$')\n",
        "        plt.plot(self.x,self.yhat,'--',label=r'$(x_i,\\hat{y}_i)$')\n",
        "        plt.legend()"
      ],
      "id": "dca70ffb-206b-4eab-9971-8f37a5d4bdbf"
    },
    {
      "cell_type": "code",
      "execution_count": 64,
      "metadata": {},
      "outputs": [
        {
          "output_type": "display_data",
          "metadata": {},
          "data": {
            "image/png": "iVBORw0KGgoAAAANSUhEUgAAAXIAAAD4CAYAAADxeG0DAAAAOXRFWHRTb2Z0d2FyZQBNYXRwbG90\nbGliIHZlcnNpb24zLjcuMSwgaHR0cHM6Ly9tYXRwbG90bGliLm9yZy/bCgiHAAAACXBIWXMAAAsT\nAAALEwEAmpwYAAAnxklEQVR4nO3de3hU9bno8e+bkJCAQJAgSCAEUSESLGjqDTeKoGB1awR1t7VV\nj93FtrbdtT20sKtW20ehm6rH/bR9Wk61rbuItIrIrq1oRY4tVSsIWy6CCMglXAQ0gBJISH7njzWT\nmzOZmazbb828n+fJA3Nb81trZr3zrt9VjDEopZSKrrywC6CUUsodDeRKKRVxGsiVUiriNJArpVTE\naSBXSqmI6xbGm5aWlpqKioow3loppSJr1apVB4wx/TveH0ogr6ioYOXKlWG8tVJKRZaIbE90v1at\nKKVUxGkgV0qpiNNArpRSERdKHXkijY2N7Nq1i2PHjoVdlNAUFRUxePBgCgoKwi6KUipCrAnku3bt\nolevXlRUVCAiYRcncMYYDh48yK5duxg2bFjYxVFKRYg1gfzYsWM5G8QBRIR+/fqxf//+sIuilOqi\nxatrmbt0E7vr6hlUUsyMySOoGVvm+/taE8iBnA3icbm+/0pF2eLVtcxatJb6xiYAauvqmbVoLYDv\nwVwbO5VSygNzl25qCeJx9Y1NzF26yff31kCulFIe2F1Xn9H9XtJArpRSHhhUUpzR/V7SQN5BfX09\nl1xyCU1NTamf3AUNDQ2MHz+eEydO+LJ9pVQ4ZkweQXFBfrv7igvymTF5hO/vHdlAvnh1LePmLGPY\nzOcYN2cZi1fXerLdxx57jKlTp5Kfn5/6yV1QWFjIxIkTWbhwoS/bV0qFo2ZsGbOnjqaspBgBykqK\nmT11dCC9ViIZyOOtw7V19RhaW4e9CObz58/n2muvBWDChAm8+OKLANx111184xvfSPn6devWcdFF\nF7XcfvPNN5k4cWK759TU1DB//nzXZVVK2aVmbBkrZl7GtjlXsWLmZYEEcbCs+2G6OmsddnPgGhoa\n2Lp1K/Epdu+77z7uuece3n//fVavXs2SJUtSbuOss85i69atNDU1kZ+fz7e//W0eeuihds+pqqri\njTfe6HI5lVKqrUhm5H61Dh84cICSkpKW2+PHj8cYw0MPPcSTTz7ZUt1y9913J91GXl4eo0aNYv36\n9Tz99NMMHTqUc845p93r8vPzKSws5MiRI67Kq5RSENGMfFBJMbUJgrbb1uHi4uJ2c72sXbuWPXv2\n0K9fP3r16gXA3r17aWxs7HQ7F1xwAStWrODnP/85zz//fMLXHT9+nKKiIlflVUopiGhG7lfrcN++\nfWlqauLYsWPs2bOHm266iWeffZaTTjqpJSCvWbOGMWPGtLxm4sSJ1Na2r5u/4IILuOuuu7juuuso\nKyv7xOsOHjxIaWmpTo6llPJEJAO5n63DV1xxBS+88AJTp07lwQcfpLKykrvvvpv77rsPaB+Qm5ub\neffddzn55JPbbWPkyJF0796d733vey33tX3dyy+/zFVXXeW6rEopBR5WrYhIPrASqDXGXO3VdpOp\nGVvmS4vwHXfcwcMPP8yrr77act/48eNbbm/evJkzzzwTgA0bNjBt2jSKi9tX6TzyyCPMnj2bnj17\nttzX9nVPPPEEc+bM8bzsSqnc5GVG/m/A2x5uLxTnnHMOEyZMSDog6NFHHyUvzzlsVVVV7XqkbNmy\nhZEjR1JfX88tt9yS8HUNDQ3U1NS0BHWllHLLk4xcRAYDVwH3A9/2Ypthuu2227r0uuHDh7Nx48ZO\nn1NYWMjNN9/cpe0rpVQiXmXk/wf4LtCc7AkiMl1EVorISp1zWymlvOM6kIvI1cD7xphVnT3PGDPP\nGFNtjKnu37+/27dVSikV40VGPg64RkTeA54ELhOR33mwXaWUUmlwHciNMbOMMYONMRXAZ4Flxpgv\nuC6ZUkqptESyH7lSSqlWng7RN8YsB5Z7uU2llFKd04xcKaUiTgO5T9auXcvAgQNZu3Zt2EVRSmU5\nDeQ+eeCBB/j73//OAw88EHZRlFJZTgN5B16t2blgwQJOO+00FixY0O5+XbNTKeU1DeQd6JqdSqmo\n0UDega7ZqZSKmkiuEOQXXbNTqeQWr65l7tJN7K6rZ1BJMTMmjwhscWHVOXsD+a8TLLwwqgbO+zI0\nHIX5N3zy8TGfh7E3wccH4fcdZhj8X8+lfMvO1uxcvnx5WtUtbdfs3Lx5c7s1O+PartkZX0JOKZst\nXl3LrEVrWxY9r62rZ9Yip0eWBvPwadVKG8nW7CwsLGwXcDtbfBla1+y899572/Vaafs6XbNTRcnc\npZtagnhcfWMTc5duCqlEqi17M/LOMujCHp0/3rNfWhl4R23X7Pzwww9b1uz85je/yfPPP8+UKVM+\nsYjyxIkTefzxx1vW5gQnkN96663ccccdLfe3fZ2u2amiZneCxc47u18FSzPyDnTNTqU+aVBJcUb3\n55LFq2sZN2cZw2Y+x7g5y1i8ujb1izymgbyDO+64gz/84Q+8+uqrXH755UD7NTvbBuRM1uxs+7on\nnniC22+/3f+dUcojMyaPoLigfRtRcUE+MyaPCKlEdoi3HdTW1WNobTsIOphrIO8g1ZqdbRdRzmTN\nzvjrdM1OFUU1Y8uYPXU0ZSXFCFBWUszsqaM7bei0IVP1my1tB2KMCfQNAaqrq83KlSvb3ff2229T\nWVkZeFlso8dBZYOOvVzAyeBTBf+oGTbzORJFUAG2zfG++lREVhljqjverxm5UspztmSqfrOl7UAD\nuVLKc7nSy8WWtgMN5Eopz9mSqfqtK20HfnDdj1xEioBXgO6x7T1ljPmB2+0qlS1ycWj7jMkjEtaR\nZ2Mvl5qxZaF/nl4MCDoOXGaM+UhECoC/icifjTGvZbohYwwi4kGRosnPhudcDCY2yNWh7fF90+9c\nMFwHcuNEn49iNwtifxlHpKKiIg4ePEi/fv1yMpgbYzh48KAvw/ZzNZjYoLNGv2w/9jZkqrnCkyH6\nIpIPrAJOB35mjHk9wXOmA9MBysvLP7GNwYMHs2vXLvbv3+9FkSKpqKiIwYMHe77dXA4mYcuVRj8V\nLk8CuTGmCRgjIiXAMyJSZYxZ1+E584B54PQj77iNgoIChg0b5kVxVAcaTMIzqKSY2gTHOZsa/bTa\nLrEgj4unvVaMMXXAy8AUL7er3MmVHgQ2sqV7ml9sGaJum6CPi+tALiL9Y5k4IlIMXA5sdLtd5Z1s\nDyY2s6V7ml9yZeBPpoI+Ll5UrZwK/DZWT54H/N4Y80cPtqs8oj0IwpXNjX5abZdY0MfFi14rbwFj\nPSiL8lE2BxMVnmxsA/Cibjvo46IjO5XKYn7PQJht1XZe1W0HfVw0kCuVpYJocMu2NgCv6raDPi7W\nTGOrlPLWuDnLEl7el5UUs2LmZSGUyGFzd8Vk09KCc9zCLmuyaWztXbNTKeWKjQ2Rfo4y9rNu2+uy\nek2rVpTKUjaOH/CrW56fddtel9UPGsiVylI2NkT6dZXgR912MjZ2rdRArlSWsrEh0q+rBC9/IGrG\nlrFi5mVJg7mNXSu1jlwpj9jYiGfb+AG/5in3o992lOZUz5lAbuNJprJHuo14uf499GuUsR9BN0oj\nonOi+2GurOitwpNOVz/9HnZNuj9+ufAjmdPdD3U+buVWqiCRTh2tfg8zl0l3RduqkYKUE42dNvan\nVdGRTte2dBrxbP0e+j2M3w2dXTE9ORHIbexPq8KVSfBKJ5ik09XPxu+h7fOJ2/rjZ5ucCOQ29qdV\n4ck0eKUTTNLp6mfj99D2jDfZj5wB664ewpQTdeRRan1W/su0rjrdrm2p6mht/B7anvEm6o0SZ/OQ\n+aDlRCCH3G4IyRZe9UrINHh52bXNtu+h7fOJt/3xS1RObSx25ETVioo+L+ty071cj9ej37lwDd27\n5dG3R4E1IyS9YmN1T0fxkZaS5HFbrh7C5DojF5EhwOPAAJxzYZ4x5hG321XZw4tM2suue+lcrq/c\n/gFPr6pteU5dfSPFBfk8/C9jsiKAx9lY3ZOM7VcPYfKiauUE8B1jzJsi0gtYJSIvGmM2eLBtFXFe\nTVvq9Vwa0Pnl+oLXd9LUYbBctl7G21bdk0yUhswHzYs1O/cAe2L/PyIibwNlgAbyHJAq2/Yqk/Y6\nG4sHr2QLCXQM4nF6GR+eKF098NF+2LcW9q2HvevANMG0X/n2dp42dopIBc5CzK97ud2uyIXhunFh\n7Ws62bZXmXTQky3liyQM5noZHy7rrh5ONMCBd+DAJqia5tz37Ndh9X+1PqfXqVB2LhgDkqym3x3P\nArmInAQ8DXzLGHM4wePTgekA5eXlXr1tQn6uQmKbMPc1nWzbq0w66MmWpp1b1q6OPH6/XsZHj2eJ\nTjwQb3sFVs+Hfetg/yZobnQeH3YJ9CyFkVfDKZUwoMr569nP2x1KwJNALiIFOEF8vjFmUaLnGGPm\nAfPAmTTLi/dNJpfmtAhzX9PJtm3vutfZD0T10JMjc1WXS1egmehSohPPsvetc/72rnOqSL64CAaO\nhrodTjAfMApOn+TcN6AKivs6rx8xJYhda8eLXisCPAq8bYx5yH2R3LN9kIOXku1TbV094+Ys8/WE\nTifbjkK9ZrIfCOsu45PIpSvQTHWa6IwZBB+931qXfdoEOPVsJ0jPj1WT5HeHU0bCGZdDfqFz35ib\nYOwXAt6TznmRkY8DvgisFZE1sfv+3RjzJw+23SW51E2pK4vFepW9pZttRyUgRlUuXYFmKp7oFNJI\nEQ0cpielHOLHHz8Ac/fC0QOtT57yYyeQDz4Xpj3qZNn9Tod8J0wuXl3L3EeXWZmQeNFr5W+QtK9+\nKILqpmTD5WxnfaLhkye0l9lbFLLtXJBLV6BpMQa2vAR71/GLHi8x9MQ2hstuftc0iftO3MIhetK3\nWwPbS8fzzO4SXjs6iEO9zuD27p+mBpwqktHXt9uk7Vc9WTlEP4gAY8sHm6pPNPg7J7Zm2+HLpSvQ\ndk4cdxob98XqsIv6wCXfdRokn/06HNnDPxUN5B9Ng3ipaSx/ax4NQLeC7iz41GPtG7MP0en5a/tV\nT1YGcvA/wNj0wcb3NdkqNVGYE1t1XdYPlDEGPtoHdTthyKed+566DTY8C80nnNvdiuCMK1pfc9NT\n0HsQPXqcTN3qWp6IJXVlsaQu0/PX9vMmawO532z8YNM5oXM2e/OJDdVrWVnFte0VeGcp7I01RB49\nAIUnwcydkJcHQ86HvhWxLn6j4OThLXXZAAysavlvoqTuzoVrEr5tsvPX9vNGA3kX2fjBpnNCZ332\nFiBbqtfi7xepwG0MHNnb2sVv33rn77bnnSqSbX+FN37l9McecaUTsAdWQXwc7vm3u3r7TM9f288b\nDeRdZOsHG8U5saPKpuo1qzUeg/0bnUA9/DLofaoz8nHJN1qf03uwE6iPHXYC+cXfgktnQl5+0s26\nken5a/t5o4G8i2z/YDsTuezNUjZWr4XKGGhucqo4PtgKy+53su0Dm525RgCuf8wZyj50HFz5H7Gq\nkbNaB9PEFfb0tahdOX9tPm80kLeRaX2nzR+s8p+N1WuBaW5qrb9uOwJy/P+GC++AvG6w83UnUI+8\n2sm2B1TByac5r+833PkLUTadvxrIY2yq71TRYGv1mqeMgSN7YsPU10GfIXD2DSx58z2u+uME8mnm\nGIXUl4ygb+XVrDh8Ct+dEx8085/MqIzGVWrUaSCP0fpOlamgqtcC6xnTWO8MWe871Ln9+5udRsf6\nD1qfM/pGFjddxKxnN7Oo6TtsNwPZbgbQ/WAB0yrKePpvtdQ3OlcpmgwFRwN5jNZ3qq7w+/Lc1yvF\n7a/Cjr+3Tgp1cDP0Hwlfe9V5/KQBUPnPrT1GBoyCoj7MnbOM+sYmljO2ZVO5thiHbTSQx+R0fWcW\ns6GftxudXSnGH+903xrr4f23W+uyP3wPPvekM/px1a/hrYVQUu4E67OugVM/1fraz8xNWKZkyU0U\nFuOI+vchGQ3kMTlR35ljotDukSqwdDa7Zft9O8oji15mwN48Lpx0HRQUw4pH4C/3gml2XlTQ0+kh\ncvwIFPWGSfc5wbqoT0ZljupiHFH4PnSVBvKYKHcnVInZ3u6RTmDpLGgOPrGdz3d7icq8HYyUHZTI\nx87aXGePcFakKTsXxs9wqkQGVEHfYc6oyLjep3ap3FFdjMP274MbGsjbyKbuSMr+do+UgcUY7vmn\nXix+/lWGNb9HZd4OKmUHD5ov8OfGMZTmHeLG/OW8Y4bwp6bz2WCGsql5CH845SxnYxUXO38ei+pi\nHLZ/H9zQQB5R2VrX5yXb2z3aBpAijnOm7KIybwdbD50KXAYHtzD5xUlMzgfyYUdzf7Z1O43PXziK\nt1YV83pdJVXHH8XQmmWXlRQ71So+i+JiHLZ/H9zQQB5B2VzX5yUr2z2MgYaPoftJDO5TyPeO/oRK\n2U6F7CVfnPrl35643Fnd6YrTqbnqQRgwGk6ppLyoN/HVbmeU1tq3b5az8vvgEQ3kERR0XV9Us38r\n2j32/A/sXtNmYqh1zvD0zy3gO1POov/iw7zbXMZ/N1/I283lbDTl7DCnYOrqmfXMBph6JTXliTPf\n0PctYrL5mIlJ0mXIT9XV1WblypWBv2+2GDbzORJ9agJsm3OVp+/VMfsHJ4uZPXV0VpwAnjAGDu10\nAvXeddBwBC7/ofPYo5Nh52vOFKynnOX0xy6/CM6+AWj9kUy2KEhZSTErZl4W1J4oy4nIKmNMdcf7\nPcnIReQx4GrgfWNMVarnK3eCrOvL5pb+Lmn42FmVpuwc5/ay++H1X8LxQ63P6V/pdO0Tgat+4kwA\nVVLRvsdITLxOOdmPczY0xCmHn1e2XlWt/Ab4KfC4R9tTnQiyri+bW/rTsm89bHyutWrk4BbAwIwt\n0LPUmQRq9PVO/+wBo51/u/dqff3A0Wm9TTY3xIXBtupAv9u1PAnkxphXRKTCi22p1IKs68uJANPw\nsTP6se1sflc/7CxqUPsmvHy/E7AHjILRNzh9suM9Q8Z8zvlzKZsb4oJmY2cAv69sA2vsFJHpwHSA\n8vLyFM9WqQTVzSurAowxULfDCdT9RzrTqL73N/jN1bSsPFPYywnYDUed21VTYdR10P0kX4uW7o+z\nm0zTtizVLzZWB/p9ZRtYIDfGzAPmgdPYGdT7RpFNJ5ytM/ylfL4xTh11fR0s+1HrUmLHDzuPT7oX\nLr7TCeiXznKC98AqKBnqvC7O5wUO2kr14+wm07QxS/WLjdWBfl/ZavdDy9h4wtk2w1/H58uh7by4\naAUjNh2jUmIZ95lTYMpsKOgB65+BfmfA2TfGhqs7/bIBp5770u/5tm9ecpNp2pil+sXG6kC/r2wj\nE8htylL9lEsnXFy6M/wN7wN3nye88+r/45rmJhYyAYCnCu9joHxI80aBk4c5ddjxWfy6FToNk22z\n7Ihyk2namKX6xcbqQL+vbL3qfrgAuBQoFZFdwA+MMY96sW2wM0v1Sy6dcHEd901oppRD1NbBrEVr\n+ab5HVcW/oOK4/vgr3AJsDa/goVNTiCf2fiv1JlebDaDWf/NaZ98gywI4uAu07QxS/WLrQN//Lyy\n9arXivtm+07kUpaaSydc3IW9DzDs4zVUynZG5u1khOwEYGzDr6hvbKKxWz7rzVCeahzPRlPOO2Yo\nO0y/ltcvb3YWOCjL4mME7jJNG7NUP9k854sfIlG1kktZataecM3NUPde6+jHfeug5udQ1Id7Kt5m\n5DuPcdj0YKMZwqKmi9mSNwwxTUA3Hjpx4yc2V1yQn33HKAU3maatWaryRiQCeS5lqV6ecKG1Kxw/\nAvs2QOkZ0ONk2LAEFn8VGj6KPUGcrn9H9kFRH0b+87dY+tY0fvjKYXYfOtZS1peSDF0viz2ei0HJ\nTaaZzmuD/s7kStuX3yIx14rO95G5QI/Zkb2w8tex0Y+x5cQArv+10w9733rn8YFVrT1GCnvYtQ8q\n8OOtn2/mks21EolADvrLnalxc5YlzWa7NAnTscPw/obWoep71zkjGqtvgw+3wyOfgn6ntw5VH1gF\nQ853MnIX9HP3R6LjmmzyLr8m7vL8O5oDfJ00Kwi51niRSCZBrcvtCs3N8OE2J1gX9oTTJ0LjMfhx\nBZhY5lTUx+niVxgb7VhSDv++O60sO1M2VgdEXbJeYB07FMT51RaVS21ffotMIPdLVIJApl0w02pX\nONHg9LMGePEe2P53p2678WPnvuETnUBeUARX/hj6DHEy7d5l7bv0ifgSxNORS11TvZKsF1jQiyfn\nUtuX33I6kEcpCGTaBbNj75cy9nNuwXa+Vl4PC34F+9ZC997w1RXOCz7YCvnd4Zwvti7W239k6wbP\n+3LKMobxo5hLXVO9kizjbTLGt95Aib4bWdtDKwQ5HcijFATSvgw9dhj2raemcR2jz1jDzbVT2X3o\nGPf0eJrJza/A5jynLrusGgaNaX3dv/zOVfnC+lEM4/I8KldxySTLhP3qDZTsuzF76mhmTx0d6WNp\ni5wO5FGqo+t48gnNDJV9mN5DnDvWPAHLZzuz+8UMLyphxb/9yGlw3FcBTQ1Olu3D4rxh/SgGfXke\npau4ZDrLhP1oi+rsu7Fi5mWROW42y+lAHqU6urvH9+GN5/+b4c3vUZm3gxGykx5ynOXnL3Se0KPU\nybLPvdWpFhkwqn1d9oBRvpYv2Y9fbV29s5CwT5lW0JfnUbqKSybowUFRSpiiKqcDuXV1dM1N8ME2\np/463sXv/Nth+ASmDPyIKXmPcSjvJDY0lfPHgss5ffT5XHreuc5rz7zC+QtJsh9F8Ddr9Toopao2\nyZagFGQvsCglTFGV04E81GHL9XVOsC7u6/S9rtsJPzsPGmMLGki+MzIyPn/2kPPhzg306T2IC0W4\n0P8SZiTRj2JbfmatXgWldKpNNChlzrqEKQvldCCHYObadn4ojvKDnouZUrqfgce2OKuugzOg5uqH\nofcg5/+nVLb2GCkoat1QQRH0sePSvbOstbMV4YPKWrvaGJlOtUm6QSnqDaJe8mv1Iz3GrXI+kHsq\nnmXHhqp/sHU1BR/0orbh64AwvvGvfLS3GzsHf4ohn/6SE7AHnu28Ni8fJt8fZunTkiprrRlblnTE\nXhBZq5vGyHSqTdIJStnQIOo1r1c/0mPcngbyrmhuclZT37cOPj4A50937n/iRtj5uvP/4pPZeryM\n9U2DW142qeEnNJNH2cFiVlxsxxDkTLMaL7NWP7hpjEy32iRVUMqGBtG4oLLeTI9ZNh1jL2ggT6W+\nDopLnP+vfAzefNxZcf3EMee+wpPg0/8KeXlwyffANDuZdq+B3DDrT7QdJ9dMHmBPw1iirObOhWv4\n1sI1LX2KO54UXmWtfnHTGOnVD1C2NIgGmfVmesyy5Rh7RQN5W0f2wvYVbebMXg+Hd8GMrdCznzOk\nvXtvqP5S62K9/Uc6QRyc4ext2N4wliirif/wJDtp3Watfmd4bo65Vz9Atn/u6Qoy6830mGXLMfZK\nnhcbEZEpIrJJRN4VkZlebNNXRz+AbX+F134Bz94BB9517t/8Ijx1G6x4xGmMHHqhs9p6vC/2BV+B\nW5bAlAdg7E3OupDduid9mxmTR1BckN/uPpta61NlL23XzYxzs0/xDK+2rh5D64/F4tW1GZc9GbfH\nvGZsGStmXsa2OVd1ebCK7Z97uoLMejM9ZtlyjL3iOiMXkXzgZ8DlwC7gDRFZYozZ4HbbrjWdgA+2\nOLP19RoIu1fDkzfB4TaBo0cpVE2D0tNhxJVw+ytOlt1JgE5XxwyvT3EBInDnwjXMXbop9Fb2zvp+\nx3U8ad1krUFkeDashGNDGbwQZNab6bkS9PgB27mej1xELgTuNcZMjt2eBWCMmZ3sNV2ZjzwtDUfh\nzd86jZB718H+jU5d9qT74OJvOSvSvHBX66RQA6vgpAGBLM5r4yT6icrUkZdzQw+b+RyJvm0CbJtz\nlSfvobwT1ndWF7hIzs/5yMuAnW1u7wLOT1CA6cB0gPLy8q6/W9MJOPhu62o0+9bD4E/DJd+FvG7w\nwt1OBj6wymmEHDAKhl7kvLbXAJj2f7v+3i7Y2Mrese+3QLtA6/WlaroZXtSzo2wR1pVF0OeKjedm\npgJr7DTGzAPmgZORd3lDPz23dSmxvG6xxsZYXVm3QvjOJmeSqACy7EzY2sretlHS7wCaTq8Q7R9s\nlzAWdAn6XLH13MyEF4G8FhjS5vbg2H3+uPhO6FbkVI2Untm6MEJcz36+vbUbUWhl9/ukTSfDy4bs\nSLkT9LkShXMzFS8C+RvAGSIyDCeAfxb4vAfbTezcW33btJ9SZaO5Up2Q6sciG7Ij5U7QA8qyYS4Y\n14HcGHNCRL4OLAXygceMMetdlyzLdJaNanVCq2zIjpQ7QdfNZ0MvI9e9VrrCt14rEZWrq4knugoB\nItODwFa5cnWXi5L1WvFkQJByJxerE5INDgKYPXU0ZSXFCM6PmQbx9AUx6Eo5x3ncnGUMm/kc4+Ys\nC/346hB9C+RidYIu/+UPbSz2n41VoZqRW8DG4cZ+Zxy5eBWSia4efz2u/uvsxzIsWZWRR6lusGNZ\np51bxssb91tR9iAyjly8CkmXm+Ovx9V/Nv5YZk1GHqW6wURlfXpVLTMmj3A1WZNXgsg4bLwKsYWb\n46/H1X+dzcgYlqwJ5DZe7iRje1mDyDhqxpZpo2YSbo6/Hlf/2fhjGfmqlXgVRdjrRGbCxkuztoK6\nPA9j+HcUuD3+elz9ZWO/80gH8nRm77OxbtD2esxsGOkWZXr87Wfbj2Wkq1YSVVG0ZeuX38ZLs7b0\n8jxcevxVpiI9sjPZ/NZA0jUnbRGlHjZKKTv4OR95aJJVUURhaLttl2ZKqeiKdNWKTVUUtg3ZVUrl\njkhn5H62HmdS9WHjkF2lVO6IdCCHrlVRpArSmQZmnd9CKRWmSFetdEU6I0AzHbBje79wpVR2i3xG\nnql0sufOAnOibN72fuFKqeyWcxl5OtlzsgDcp7ggYTY/YWR/axpdVXLaIK2ylatALiI3iMh6EWkW\nkU/0bbRROhPeJOsNI0LCbP7ljft1AIflojSpmlKZclu1sg6YCvzSg7IEIp3hz8l6w9y5cE3Cbe6u\nq9d+4ZbTBmmVzVwFcmPM2wAi4k1pApBul8VEgTnZ5FxaF24/bZBW2Sywxk4RmQ5MBygvLw/qbRPq\navaskxlFlzZIq2yWso5cRP4iIusS/F2byRsZY+YZY6qNMdX9+/fveolDpJMZRZdNo4CV8lrKjNwY\nMymIgkSF1oVHk41zSCvllZzrR65yl/4Iq2zltvvhdSKyC7gQeE5ElnpTLKWUUuly22vlGeAZj8qi\nlFKqC3JuZKdSSmUbDeRKKRVx2thpOV0STimVigZyi+mCFUqpdGjVisUynRddKZWbNJBbTOcHUUql\nQwO5xdKZclcppTSQpyGsBQl0fhClVDq0sTOFMBscdX4QpVQ6NJCnEPaCBDo/iFIqFa1aSUEbHJVS\nttNAnoI2OCqlbKeBPAVtcFRK2U7ryFPQBkellO00kKdBGxyVUjbTqhWllIo4DeRKKRVxbpd6mysi\nG0XkLRF5RkRKPCqXUkqpNLnNyF8EqowxZwPvALPcF0kppVQm3K7Z+UKbm68B17srTnbQxSCUUkHy\nstfKbcDCZA+KyHRgOkB5ebmHb2sXXQxCKRW0lFUrIvIXEVmX4O/aNs/5PnACmJ9sO8aYecaYamNM\ndf/+/b0pvYV0MQilVNBSZuTGmEmdPS4itwJXAxONMcajckWWzs2ilAqa214rU4DvAtcYY456U6Ro\n07lZlFJBc9tr5adAL+BFEVkjIr/woEyRpnOzKKWC5rbXyuleFSRb6NwsSqmg6VwrPtC5WZRSQdIh\n+kopFXEayJVSKuI0kCulVMRpIFdKqYjTQK6UUhGngVwppSJOA7lSSkWcBnKllIo4DeRKKRVxGsiV\nUiriNJArpVTEaSBXSqmI00CulFIRp4FcKaUiTgO5UkpFnAZypZSKOLdrdv5IRN6KLfP2gogM8qpg\nSiml0uM2I59rjDnbGDMG+CNwj/siKaWUyoTbNTsPt7nZEzDuipOexatrdU1MpZSKcb1mp4jcD9wM\nHAImdPK86cB0gPLy8i6/3+LVtcxatJb6xiYAauvqmbVoLYAGc6VUTkpZtSIifxGRdQn+rgUwxnzf\nGDMEmA98Pdl2jDHzjDHVxpjq/v37d7nAc5duagnicfWNTcxduqnL21RKqShLmZEbYyalua35wJ+A\nH7gqUQq76+ozul8ppbKd214rZ7S5eS2w0V1xUhtUUpzR/Uople3c9lqZE6tmeQu4Avg3D8rUqRmT\nR1BckN/uvuKCfGZMHuH3WyullJXc9lqZ5lVB0hVv0NReK0op5XDdayUMNWPLNHArpVSMDtFXSqmI\n00CulFIRp4FcKaUiTgO5UkpFnAZypZSKODEmkHmu2r+pyH5gexdfXgoc8LA4UaD7nBt0n3ODm30e\naoz5xBwnoQRyN0RkpTGmOuxyBEn3OTfoPucGP/ZZq1aUUiriNJArpVTERTGQzwu7ACHQfc4Nus+5\nwfN9jlwduVJKqfaimJErpZRqQwO5UkpFnLWBXESmiMgmEXlXRGYmeLy7iCyMPf66iFSEUExPpbHP\n3xaRDSLyloi8JCJDwyinl1Ltc5vnTRMRIyKR7qqWzv6KyI2xz3m9iDwRdBm9lsb3ulxEXhaR1bHv\n9mfCKKeXROQxEXlfRNYleVxE5D9jx+QtETnH1RsaY6z7A/KBLcBpQCHwP8BZHZ7zNeAXsf9/FlgY\ndrkD2OcJQI/Y/7+aC/sce14v4BXgNaA67HL7/BmfAawG+sZunxJ2uQPY53nAV2P/Pwt4L+xye7Df\n44FzgHVJHv8M8GdAgAuA1928n60Z+XnAu8aYrcaYBuBJnKXk2roW+G3s/08BE0VEAiyj11LuszHm\nZWPM0djN14DBAZfRa+l8zgA/An4MHAuycD5IZ3+/DPzMGPMhgDHm/YDL6LV09tkAvWP/7wPsDrB8\nvjDGvAJ80MlTrgUeN47XgBIRObWr72drIC8Ddra5vSt2X8LnGGNOAIeAfoGUzh/p7HNbX8L5RY+y\nlPscu+QcYox5LsiC+SSdz/hM4EwRWSEir4nIlMBK54909vle4AsisgtnAfdvBFO0UGV6vncqkisE\n5ToR+QJQDVwSdln8JCJ5wEPArSEXJUjdcKpXLsW54npFREYbY+rCLJTPPgf8xhjzoIhcCPyXiFQZ\nY5rDLlhU2JqR1wJD2tweHLsv4XNEpBvOJdnBQErnj3T2GRGZBHwfuMYYczygsvkl1T73AqqA5SLy\nHk5d4pIIN3im8xnvApYYYxqNMduAd3ACe1Sls89fAn4PYIx5FSjCmVgqm6V1vqfL1kD+BnCGiAwT\nkUKcxswlHZ6zBLgl9v/rgWUm1ooQUSn3WUTGAr/ECeJRrzuFFPtsjDlkjCk1xlQYYypw2gWuMcas\nDKe4rqXzvV6Mk40jIqU4VS1bAyyj19LZ5x3ARAARqcQJ5PsDLWXwlgA3x3qvXAAcMsbs6fLWwm7d\n7aTV9zM42cgW4Pux+36IcyKD82H/AXgX+AdwWthlDmCf/wLsA9bE/paEXWa/97nDc5cT4V4raX7G\nglOdtAFYC3w27DIHsM9nAStwerSsAa4Iu8we7PMCYA/QiHOV9SXgK8BX2nzOP4sdk7Vuv9c6RF8p\npSLO1qoVpZRSadJArpRSEaeBXCmlIk4DuVJKRZwGcqWUijgN5EopFXEayJVSKuL+Pw1D/+/La2ni\nAAAAAElFTkSuQmCC\n"
          }
        }
      ],
      "source": [
        "linreg = LinearRegression(x,y)\n",
        "linreg.fit()\n",
        "linreg.plot()"
      ],
      "id": "1ab13e45-a048-43f9-966c-82f9b32540b0"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> 5월24일 12wk-2 숙제참고\n",
        "\n",
        "------------------------------------------------------------------------\n",
        "\n",
        "`(2)` 앞면과 뒷면이 나올 확률이 각각 1/2인 동전을 생각하자. 하니와\n",
        "규빈은 이 동전을 연속으로 던져서 아래와 같은 룰을 정하여 내기를 하였다.\n",
        "\n",
        "-   동전을 연속으로 반복하여 던진다. 최근 2회의 결과가 (뒷면,앞면) 이\n",
        "    나오면 하니의 승리\n",
        "-   동전을 연속으로 반복하여 던진다. 최근 2회의 결과가 (뒷면,뒷면) 이\n",
        "    나오면 규빈의 승리\n",
        "\n",
        "이 내기는 하니가 유리한가? 규빈이 유리한가? 시뮬레이션을 통해 검증하라.\n",
        "\n",
        "> **Note**\n",
        ">\n",
        "> **hint**: 똑같이 유리하다\n",
        "\n",
        "`(풀이)`\n",
        "\n",
        "**Step1** CoinFlipper 설계"
      ],
      "id": "5d12a38a-7260-4343-8767-da9889d5e5a1"
    },
    {
      "cell_type": "code",
      "execution_count": 241,
      "metadata": {},
      "outputs": [],
      "source": [
        "class CoinFlipper: \n",
        "    def __init__(self):\n",
        "        self.coins = list()\n",
        "        self.win_cond = {'하니':[],'규빈':[]}\n",
        "        self.winner = str()        \n",
        "    def __iter__(self):\n",
        "        return self \n",
        "    def __next__(self):\n",
        "        self.coins.append(np.random.choice(['앞면','뒷면']))\n",
        "        if self.coins[-2:] == self.win_cond['하니']:\n",
        "            self.winner = '하니'\n",
        "            raise StopIteration\n",
        "        elif self.coins[-2:] == self.win_cond['규빈']:\n",
        "            self.winner = '규빈'\n",
        "            raise StopIteration        \n",
        "        else:\n",
        "            pass\n",
        "    def __call__(self,win_cond):\n",
        "        self.win_cond = win_cond\n",
        "        for _ in self:\n",
        "            pass \n",
        "    def __repr__(self):\n",
        "        repr_str = '하니의 승리조건: {}\\n규빈의 승리조건: {}\\n동전을 던진결과들: {}\\n최종승리자: {}'.format(\n",
        "            self.win_cond['하니'],\n",
        "            self.win_cond['규빈'],\n",
        "            self.coins,\n",
        "            self.winner\n",
        "        )\n",
        "        return repr_str"
      ],
      "id": "a6b99a05-8b51-49ba-ab8b-24bd0b86824e"
    },
    {
      "cell_type": "code",
      "execution_count": 242,
      "metadata": {},
      "outputs": [],
      "source": [
        "coin_fliper = CoinFlipper()"
      ],
      "id": "632cd3b6-8f30-4019-9db5-45a725d2446e"
    },
    {
      "cell_type": "code",
      "execution_count": 235,
      "metadata": {},
      "outputs": [],
      "source": [
        "coin_fliper"
      ],
      "id": "71f59b42-7668-4c44-a725-52e3a6eef5bb"
    },
    {
      "cell_type": "code",
      "execution_count": 236,
      "metadata": {},
      "outputs": [],
      "source": [
        "win_cond = {\n",
        "    '하니':['앞면','뒷면'],\n",
        "    '규빈':['뒷면','앞면']\n",
        "}\n",
        "coin_fliper(win_cond)"
      ],
      "id": "2f6699c5-5e96-4207-9879-7b2dd2c7b894"
    },
    {
      "cell_type": "code",
      "execution_count": 237,
      "metadata": {},
      "outputs": [],
      "source": [
        "coin_fliper"
      ],
      "id": "bf1bc4b5-1666-4961-a749-de83c3eaf172"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**Step2:** 100회 대결진행"
      ],
      "id": "9924fb11-10cf-4bc6-998f-10f6e586000f"
    },
    {
      "cell_type": "code",
      "execution_count": 238,
      "metadata": {},
      "outputs": [],
      "source": [
        "coinfliper_lst = [CoinFlipper() for _ in range(100)]\n",
        "winners = [] \n",
        "for coinfliper in coinfliper_lst:\n",
        "    coinfliper(win_cond)\n",
        "    winners.append(coinfliper.winner)"
      ],
      "id": "46348d6a-95f0-48ff-b642-7b7755143e92"
    },
    {
      "cell_type": "code",
      "execution_count": 239,
      "metadata": {},
      "outputs": [],
      "source": [
        "{'하니':winners.count('하니'), '규빈':winners.count('규빈')}"
      ],
      "id": "3257073e-381a-4899-b1b7-bda57c2ee16f"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "------------------------------------------------------------------------\n",
        "\n",
        "참고로 $n$회 대결결과는 아래와 같이 조회가능"
      ],
      "id": "2a4f84e4-5bf3-45df-8f40-9af2a1380c53"
    },
    {
      "cell_type": "code",
      "execution_count": 240,
      "metadata": {},
      "outputs": [],
      "source": [
        "coinfliper_lst[3]"
      ],
      "id": "fd5e3b07-75e9-4a0b-ba4d-d717221eaea9"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "------------------------------------------------------------------------\n",
        "\n",
        "`(3)` 앞면과 뒷면이 나올 확률이 각각 1/2인 동전을 생각하자. 하니와\n",
        "규빈은 이 동전을 연속으로 던져서 아래와 같은 룰을 정하여 내기를 하였다.\n",
        "\n",
        "-   동전을 연속으로 반복하여 던진다. 최근 2회의 결과가 (앞면,뒷면) 이\n",
        "    나오면 하니의 승리\n",
        "-   동전을 연속으로 반복하여 던진다. 최근 2회의 결과가 (뒷면,뒷면) 이\n",
        "    나오면 규빈의 승리\n",
        "\n",
        "이 내기는 하니가 유리한가? 규빈이 유리한가? 시뮬레이션을 통해 검증하라.\n",
        "\n",
        "> **Note**\n",
        ">\n",
        "> **hint**: 이 내기는 하니가 유리하다.\n",
        "\n",
        "`(풀이)`"
      ],
      "id": "50ef8669-c5c6-4b54-a434-d22d969a88c6"
    },
    {
      "cell_type": "code",
      "execution_count": 246,
      "metadata": {},
      "outputs": [],
      "source": [
        "win_cond = {\n",
        "    '하니':['앞면','뒷면'],\n",
        "    '규빈':['뒷면','뒷면']\n",
        "}\n",
        "coin_fliper(win_cond)"
      ],
      "id": "7b79ce04-86c9-43d2-8c7a-0d449d633714"
    },
    {
      "cell_type": "code",
      "execution_count": 247,
      "metadata": {},
      "outputs": [],
      "source": [
        "coinfliper_lst = [CoinFlipper() for _ in range(100)]\n",
        "winners = [] \n",
        "for coinfliper in coinfliper_lst:\n",
        "    coinfliper(win_cond)\n",
        "    winners.append(coinfliper.winner)"
      ],
      "id": "54c26e71-6a8f-4a98-b7c4-6f79f5e567f7"
    },
    {
      "cell_type": "code",
      "execution_count": 248,
      "metadata": {},
      "outputs": [],
      "source": [
        "{'하니':winners.count('하니'), '규빈':winners.count('규빈')}"
      ],
      "id": "32135e93-56e2-4584-990f-e0d7949e9914"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "------------------------------------------------------------------------\n",
        "\n",
        "`(4)` Time을 상속받아 Init 클래스를 만들고 `__repr__`을 조작하여 아래와\n",
        "같이 인스턴스 생성시점을 출력하는 기능을 구현하라."
      ],
      "id": "737758f9-e72a-44fd-b528-866c3885453b"
    },
    {
      "cell_type": "code",
      "execution_count": 230,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Time:\n",
        "    def time(self):\n",
        "        return datetime.datetime.now().strftime('%y-%m-%d %X')"
      ],
      "id": "bdf5381e-7a91-4c8d-a74a-42684628be2f"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(풀이)`"
      ],
      "id": "8eae3f30-3d97-4f5c-b4c9-f10bbc4e8e31"
    },
    {
      "cell_type": "code",
      "execution_count": 249,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Init(Time):\n",
        "    def __init__(self):\n",
        "        self.init_time = self.time()\n",
        "    def __repr__(self):\n",
        "        return '인스턴스생성시점: {}'.format(self.init_time)"
      ],
      "id": "b75df7e7-335b-4051-a6e4-c26645c10c8c"
    },
    {
      "cell_type": "code",
      "execution_count": 250,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = Init()"
      ],
      "id": "03cc19b6-4197-4f45-9dd6-421b6c4e49a2"
    },
    {
      "cell_type": "code",
      "execution_count": 251,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "37468a08-14e9-4613-9c26-e53c7cd1567d"
    },
    {
      "cell_type": "code",
      "execution_count": 252,
      "metadata": {},
      "outputs": [],
      "source": [
        "b = Init()"
      ],
      "id": "a3f4d1cc-d3e6-49e9-8e88-a9813d3d879e"
    },
    {
      "cell_type": "code",
      "execution_count": 253,
      "metadata": {},
      "outputs": [],
      "source": [
        "a,b"
      ],
      "id": "64f0e7aa-381e-45f5-9038-17877ab5e31e"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "------------------------------------------------------------------------\n",
        "\n",
        "`(5)` tuple 클래스와 아래의 Check를 상속받아 아래와 같은 역할을 하는\n",
        "새로운 Tuple 클래스를 만들라."
      ],
      "id": "a88fe474-565c-4055-9a92-f417a2c838a4"
    },
    {
      "cell_type": "code",
      "execution_count": 254,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Check:\n",
        "    def ckeck(self):\n",
        "        return [l for l in dir(self) if l[0]!='_']"
      ],
      "id": "acfd1c37-e900-4544-9099-158d0d806321"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(풀이)`"
      ],
      "id": "65aa0f2e-fc43-4f3e-b141-e78da2fef678"
    },
    {
      "cell_type": "code",
      "execution_count": 271,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Tuple(Check,tuple):\n",
        "    def freq(self):\n",
        "        return {s:self.count(s) for s in set(self)}\n",
        "    def __repr__(self):\n",
        "        return super().__repr__() + '\\n' +'methods={}'.format(self.ckeck())"
      ],
      "id": "04304069-3696-456f-a8d9-f9c96b6ce041"
    },
    {
      "cell_type": "code",
      "execution_count": 272,
      "metadata": {},
      "outputs": [],
      "source": [
        "tpl = Tuple('asdfassdfsasdf')\n",
        "tpl # 값과 함께 사용가능한 메소드가 함께 출력 "
      ],
      "id": "fdae6374-c612-491b-9eb8-780c160d0292"
    },
    {
      "cell_type": "code",
      "execution_count": 273,
      "metadata": {},
      "outputs": [],
      "source": [
        "tpl.freq()"
      ],
      "id": "9f2f73c2-0f3c-447c-a4c2-0c04d5f37949"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "------------------------------------------------------------------------\n",
        "\n",
        "`(6)` 아래와 같은 클래스를 고려하자."
      ],
      "id": "fd0e1602-cc0f-473b-9634-bc163cb7c44b"
    },
    {
      "cell_type": "code",
      "execution_count": 1103,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Init(object):\n",
        "    def __init__(self,value):\n",
        "        self.value = value\n",
        "        \n",
        "class Times2(Init):\n",
        "    def __init__(self,value):\n",
        "        super().__init__(value)\n",
        "        self.value = self.value * 2\n",
        "        \n",
        "class Plus5(Init):\n",
        "    def __init__(self,value):\n",
        "        super().__init__(value)\n",
        "        self.value = self.value + 5"
      ],
      "id": "2ed230a8-1c61-43fd-8ebc-4485e17e6c51"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`Plus5`와 `Times2`를 상속하여 적당한 클래스 `Times2Plus5`를 정의하고\n",
        "생성과 동시에 $x \\to (x\\times 2)+5$ 를 수행도록 하라.\n",
        "\n",
        "`(풀이)`"
      ],
      "id": "508adbdd-fe52-49f9-b757-0d5b3e86927f"
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Times2Plus5(Plus5,Times2):\n",
        "    def __init__(self,value):\n",
        "        super().__init__(value)"
      ],
      "id": "1618c537-ad35-49ec-9ca8-68012edd3535"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**사용예시**"
      ],
      "id": "3ff1d17e-337a-4fde-a297-94105d022bdd"
    },
    {
      "cell_type": "code",
      "execution_count": 1105,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=Times2Plus5(0)\n",
        "a.value"
      ],
      "id": "a3cf737e-8864-4628-9dec-3afac5d154b8"
    },
    {
      "cell_type": "code",
      "execution_count": 1106,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=Times2Plus5(1)\n",
        "a.value"
      ],
      "id": "5de1aebe-d00e-41c6-8e25-839b0beb2622"
    },
    {
      "cell_type": "code",
      "execution_count": 1107,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=Times2Plus5(5)\n",
        "a.value"
      ],
      "id": "b916f7ae-83f6-49fc-a265-9c9dd74f1702"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "------------------------------------------------------------------------\n",
        "\n",
        "`(7)` 아래의 함수가 있다고 하자."
      ],
      "id": "a884f61c-f335-423e-9e41-f91da85cb3c1"
    },
    {
      "cell_type": "code",
      "execution_count": 276,
      "metadata": {},
      "outputs": [],
      "source": [
        "def f(x): \n",
        "    return np.sin(x)"
      ],
      "id": "3fbe5122-be5f-4ef4-b531-c4b3608a47e4"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "적당한 함수 `derivate`를 정의하여 함수를 입력으로 받으면 그 도함수를\n",
        "출력으로 리턴하도록 하라. 아래의 코드를 이용하여 검증하라."
      ],
      "id": "b874cdd3-94af-419e-bbe4-e0ad575ab84a"
    },
    {
      "cell_type": "code",
      "execution_count": 277,
      "metadata": {},
      "outputs": [
        {
          "output_type": "display_data",
          "metadata": {},
          "data": {
            "image/png": "iVBORw0KGgoAAAANSUhEUgAAAYIAAAD4CAYAAADhNOGaAAAAOXRFWHRTb2Z0d2FyZQBNYXRwbG90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\nJiYmJiMc0xCYmJiYjHBMQ2BiYmIywvn/PMb/0NUihFsAAAAASUVORK5CYII=\n"
          }
        }
      ],
      "source": [
        "x = np.linspace(-6,6,100)\n",
        "plt.plot(x,f(x),label=r'$f(x)=\\sin(x)$')\n",
        "plt.plot(x,(derivate(f))(x),label=r'$f\\'(x)=\\cos(x)$')\n",
        "plt.legend()"
      ],
      "id": "b5e24b2c-bdea-43fd-a22c-28cd08878551"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(풀이)`"
      ],
      "id": "ac31003e-53ac-4041-b933-1fbfc2501f2a"
    },
    {
      "cell_type": "code",
      "execution_count": 280,
      "metadata": {},
      "outputs": [],
      "source": [
        "def f(x): \n",
        "    return np.sin(x)\n",
        "def derivate(f): \n",
        "    # step1: 함수오브젝트 f는 입력으로 받은상태 \n",
        "    # step2: 함수오브젝트 f를 이용하여 df라는 함수를 정의 \n",
        "    def df(x): \n",
        "        h=0.000000000001\n",
        "        return (f(x+h)-f(x))/h \n",
        "    # step3: 정의된 df를 리턴\n",
        "    return df"
      ],
      "id": "5ad2f7e5-bd95-4115-ae10-0c3ec26a27aa"
    },
    {
      "cell_type": "code",
      "execution_count": 281,
      "metadata": {},
      "outputs": [
        {
          "output_type": "display_data",
          "metadata": {},
          "data": {
            "image/png": "iVBORw0KGgoAAAANSUhEUgAAAYIAAAD4CAYAAADhNOGaAAAAOXRFWHRTb2Z0d2FyZQBNYXRwbG90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\nJiYmJiMc0xCYmJiYjHBMQ2BiYmIywvn/PMb/0NUihFsAAAAASUVORK5CYII=\n"
          }
        }
      ],
      "source": [
        "x = np.linspace(-6,6,100)\n",
        "plt.plot(x,f(x),label=r'$f(x)=\\sin(x)$')\n",
        "plt.plot(x,(derivate(f))(x),label=r'$f\\'(x)=\\cos(x)$')\n",
        "plt.legend()"
      ],
      "id": "57861473-4ef6-43c9-9367-e52269f9d6bd"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "------------------------------------------------------------------------\n",
        "\n",
        "`(8)` Student 클래스를 생성지침 및 사용예시를 참고하여 설계하라.\n",
        "\n",
        "**`생성지침`**\n",
        "\n",
        "**attributes**\n",
        "\n",
        "-   `name`: 이름을 저장하는 변수\n",
        "-   `age`: 나이를 저장하는 변수\n",
        "-   `semester`: 학기를 저장하는 변수\n",
        "\n",
        "**methods**\n",
        "\n",
        "-   `__init__`: name, age, semester 세 가지 매개변수를 입력받아\n",
        "    인스턴스의 attribute로 저장\n",
        "-   `__str__`: 인스턴스의 정보(이름,나이,학기)를 문자열 형태로 반환\n",
        "\n",
        "**`사용예시`**"
      ],
      "id": "773e1b26-67ee-414a-8357-0f46a5314260"
    },
    {
      "cell_type": "code",
      "execution_count": 224,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "이름: 김보람\n",
            "나이: 20\n",
            "학기: 1"
          ]
        }
      ],
      "source": [
        "# 사용 예시\n",
        "boram = Student(name='김보람', age=20, semester=1)\n",
        "print(boram)"
      ],
      "id": "ac042625-284c-443f-b04c-ae8048359d59"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(풀이)`"
      ],
      "id": "b01c477f-9ea6-4ad3-8501-8e6eafed7c6c"
    },
    {
      "cell_type": "code",
      "execution_count": 331,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Student:\n",
        "    def __init__(self,name='김보람',age=20,semester=0): \n",
        "        self.name = name\n",
        "        self.age = age\n",
        "        self.semester = semester\n",
        "    def __str__(self):\n",
        "        print_str = '''이름: {}\\n나이: {}\\n학기: {}'''.format(self.name,self.age,self.semester)\n",
        "        return print_str"
      ],
      "id": "1808dcfb-a0b2-4411-9d7f-b1e5a92d0636"
    },
    {
      "cell_type": "code",
      "execution_count": 332,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "이름: 김보람\n",
            "나이: 20\n",
            "학기: 1"
          ]
        }
      ],
      "source": [
        "# 사용 예시\n",
        "boram = Student(name='김보람', age=20, semester=1)\n",
        "print(boram)"
      ],
      "id": "f569ca4b-4245-4473-8d17-d89bdd2cf035"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "------------------------------------------------------------------------\n",
        "\n",
        "`(9)` 8의 클래스를 상속받아 Student2 만들라. `__add__` 재정의하여\n",
        "Student2의 인스턴스가 아래와 같이 동작하도록 하라."
      ],
      "id": "be1b7f64-f86e-43bb-b5c5-6138e8adef02"
    },
    {
      "cell_type": "code",
      "execution_count": 336,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "입학을 축하합니다. 당신의 나이는 20이고 현재 학기는 0학기 입니다."
          ]
        }
      ],
      "source": [
        "boram = Student2()"
      ],
      "id": "cdbbbc5c-5dc7-412e-a5bd-a45fdd5c47e3"
    },
    {
      "cell_type": "code",
      "execution_count": 337,
      "metadata": {},
      "outputs": [],
      "source": [
        "boram + '등록'+ '휴학' + '등록' + '휴학'\n",
        "boram"
      ],
      "id": "86c23d64-1333-410b-bcbc-072bdb1f7f49"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> 4학기가 지났으므로 나이는 22살이 된다. 4학기중 2학기만 등록하였으므로\n",
        "> 현재는 2학기를 마친상태이다.\n",
        "\n",
        "`(풀이)`"
      ],
      "id": "744f3d12-974d-4514-8ff6-3f1c734b79c6"
    },
    {
      "cell_type": "code",
      "execution_count": 333,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Student2(Student):\n",
        "    def __init__(self,name='김보람',age=20,semester=0): \n",
        "        super().__init__()\n",
        "        print(\"입학을 축하합니다. 당신의 나이는 {}이고 현재 학기는 {}학기 입니다.\".format(self.age,self.semester))\n",
        "    def __add__(self,registration_status): \n",
        "        if registration_status=='휴학': \n",
        "            self.age=self.age+0.5\n",
        "        elif registration_status=='등록':\n",
        "            self.age=self.age+0.5 \n",
        "            self.semester= self.semester+1 \n",
        "        return self\n",
        "    def _repr_html_(self):\n",
        "        html_str = \"\"\"\n",
        "        나이: {} <br/>\n",
        "        학기: {} <br/>\n",
        "        \"\"\"\n",
        "        return html_str.format(self.age,self.semester)"
      ],
      "id": "ff1cb2a3-ed72-47cb-a9bd-533abec5db0a"
    },
    {
      "cell_type": "code",
      "execution_count": 334,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "입학을 축하합니다. 당신의 나이는 20이고 현재 학기는 0학기 입니다."
          ]
        }
      ],
      "source": [
        "boram = Student2()"
      ],
      "id": "4b0540b0-d5fd-4c74-99c4-19ed1691bcce"
    },
    {
      "cell_type": "code",
      "execution_count": 335,
      "metadata": {},
      "outputs": [],
      "source": [
        "boram + '등록'+ '휴학' + '등록' + '휴학'\n",
        "boram"
      ],
      "id": "f975154d-0d5f-4f29-81c2-a8415a34a72a"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "------------------------------------------------------------------------\n",
        "\n",
        "`(10)` 적당한 클래스를 선언하여 $f(x)=x+{\\tt const}$를 수행하는 함수를\n",
        "생성하도록 하라.\n",
        "\n",
        "**사용예시1**"
      ],
      "id": "137769f3-1116-48a9-9f89-70b821b9082c"
    },
    {
      "cell_type": "code",
      "execution_count": 265,
      "metadata": {},
      "outputs": [],
      "source": [
        "f = AddConstant(5) # f(x) = x+5 "
      ],
      "id": "0bada165-89ff-4735-ad32-7064ca4fab7a"
    },
    {
      "cell_type": "code",
      "execution_count": 266,
      "metadata": {},
      "outputs": [],
      "source": [
        "f(10)"
      ],
      "id": "50bd0e97-f4e7-419e-9cd4-97bde3a78f6d"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**사용예시2**"
      ],
      "id": "71185d09-ed0a-41f0-a814-bc3968b0d38c"
    },
    {
      "cell_type": "code",
      "execution_count": 267,
      "metadata": {},
      "outputs": [],
      "source": [
        "f = AddConstant(-3) # f(x) = x-3"
      ],
      "id": "a2fab431-486d-413b-807c-eb0b216fe24b"
    },
    {
      "cell_type": "code",
      "execution_count": 268,
      "metadata": {},
      "outputs": [],
      "source": [
        "f(10)"
      ],
      "id": "e51199e0-f454-415e-b917-2f64e34c7d90"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`(풀이)`"
      ],
      "id": "ccd20337-806e-46cf-8ba8-ab24917b33c7"
    },
    {
      "cell_type": "code",
      "execution_count": 264,
      "metadata": {},
      "outputs": [],
      "source": [
        "class AddConstant: \n",
        "    def __init__(self,const):\n",
        "        self.const = const \n",
        "    def __call__(self,x):\n",
        "        return x + self.const"
      ],
      "id": "247912c3-2293-4e92-8a81-fbe6a7a1bd79"
    },
    {
      "cell_type": "code",
      "execution_count": 269,
      "metadata": {},
      "outputs": [],
      "source": [
        "f = AddConstant(5) # f(x) = x+5 \n",
        "f(10)"
      ],
      "id": "6e5e9dc3-686f-48ae-b328-0c73ab208e7f"
    },
    {
      "cell_type": "code",
      "execution_count": 270,
      "metadata": {},
      "outputs": [],
      "source": [
        "f = AddConstant(-3) # f(x) = x-3\n",
        "f(10)"
      ],
      "id": "17f159f4-8219-4d4d-8fc3-6fb4b42aa76c"
    }
  ],
  "nbformat": 4,
  "nbformat_minor": 5,
  "metadata": {
    "kernelspec": {
      "name": "python3",
      "display_name": "Python 3",
      "language": "python"
    },
    "language_info": {
      "name": "python",
      "codemirror_mode": {
        "name": "ipython",
        "version": "3"
      },
      "file_extension": ".py",
      "mimetype": "text/x-python",
      "nbconvert_exporter": "python",
      "pygments_lexer": "ipython3",
      "version": "3.8.16"
    }
  }
}